

_HiresAddrLow			.dsb 201
_HiresAddrHigh			.dsb 201
						
_TableBit6				.byt 1,2,4,8,16,32
_TableMul6				.dsb 256
_TableDiv6				.dsb 256
_TableMod6				.dsb 256
						




_GenerateTables
.(

	; Generate screen offset data
.(
	lda #<$a000
	sta tmp0+0
	lda #>$a000
	sta tmp0+1

	ldx #0
loop
	; generate two bytes screen adress
	clc
	lda tmp0+0
	sta _HiresAddrLow,x
	adc #40
	sta tmp0+0
	lda tmp0+1
	sta _HiresAddrHigh,x
	adc #0
	sta tmp0+1

	inx
	cpx #201
	bne loop
.)


	; Generate multiple of 6 data table
.(
	lda #0
	sta tmp0+0	; cur mul
	sta tmp0+1	; cur div
	sta tmp0+2	; cur mod

	ldx #0
loop
	lda tmp0+0
	clc
	sta _TableMul6,x
	adc #6
	sta tmp0+0

	lda tmp0+1
	sta _TableDiv6,x

	lda tmp0+2
	sta _TableMod6,x

	ldy tmp0+2
	iny
	cpy #6
	bne skip_mod
	ldy #0
	inc tmp0+1
skip_mod
	sty tmp0+2

	inx
	bne loop
.)

.)
	rts







